package com.hgwebservice.dal.dataobject.data;

import com.baomidou.mybatisplus.annotation.KeySequence;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.*;

import java.util.Date;
import java.util.List;

/**
 * 会员用户 DO
 * <p>
 * uk_mobile 索引：基于 {@link #mobile} 字段
 */
@TableName(value = "member_user", autoResultMap = true)
@KeySequence("member_user_seq") // 用于 Oracle、PostgreSQL、Kingbase、DB2、H2 数据库的主键自增。如果是 MySQL 等数据库，可不写。
@Data
@EqualsAndHashCode(callSuper = true)
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class MemberUserDO extends BaseDO {

    /**
     * 编号
     */
    @TableId
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long id;
    /**
     * 同步其他医院
     */
    private String code;
    /**
     * 头像
     */
    private String avatar;
    /**
     * 真实姓名
     */
    private String username;
    /**
     * 用户昵称
     */
    private String nickname;
    /**
     * 状态
     */
    private Integer status;
    /**
     * 手机号
     */
    private String mobile;
    /**
     * 密码
     */
    private String password;

    private String salt;
    /**
     * 生日
     */
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date birthday;
    /**
     * 民族
     */
    private String nation;
    /**
     * 性别（字典项）
     */
    private Integer sex;
    /**
     * 证件类型（字典项）
     */
    private Integer cardType;
    /**
     * 身份证
     */
    private String cardNo;
    /**
     * 地址
     */
    private String address;
    /**
     * 医保卡号
     */
    private String ybCard;
    /**
     * 病历卡
     */
    private String medicalCard;
    /**
     * 支付密码
     */
    private String payPassword;
    /**
     * 1 未婚 2已婚 3离婚 4丧偶
     */
    private Integer marriage;
    /**
     * 省
     */
    private Integer provinceId;
    /**
     * 市
     */
    private Integer cityId;
    /**
     * 区
     */
    private Integer areaId;
    /**
     * 是否能私聊 1:是 2.否
     */
    private Integer isChat;
    /**
     * 注册 IP
     */
    private String registerIp;
    /**
     * 最后登录IP
     */
    private String loginIp;
    /**
     * 最后登录时间
     */
    private Date loginDate;

    /**
     * 公众号unionid
     */
    private String weixinId;

    /**
     * 云信用户id
     */
    private String yunxinAccid;
    /**
     * 云信用户token
     */
    private String yunxinToken;

    private Long attendingDoctorId;
    private Long nurseId;
    private Long deptId;
    private Long wardId;

    /**
     * 注册来源:1东宝健康公众号\n2东宝健康小程序\n3东宝健康App\n4瑞特健康公众号\n5瑞特健康小程序 6瑞特健康App\n7扫医生码注册并入群8患者入院\n9门诊入群\n10东宝医护App\n11东宝慢病后台12微信小程序
     */
    private Integer registerFrom;


    private Integer isLocked;

    private String mobileBk;
    @TableField(exist = false)
    private String tenantName;
    @TableField(exist = false)
    private String deptName;
    @TableField(exist = false)
    private String roleNames;

    @TableField(exist = false)
    private Long insPatientId;

    @TableField(exist = false)
    private Integer age;
    @TableField(exist = false)
    private Double height;
    @TableField(exist = false)
    private Double weight;
    @TableField(exist = false)
    private List<Long> tags;


    private String pushId;

    private Date freezeTime;

}
